VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Rationnel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public numerator As Double
Public denominator As Double

Public Enum Sign
    Moins
    Plus
    Nul
End Enum

Public Sub Initialiser_Avec(Nombre As Rationnel)

Me.numerator = Nombre.numerator
Me.denominator = Nombre.denominator

Regulariser

End Sub

Public Sub Ajouter_Avec(Nombre As Rationnel)

Me.numerator = (Nombre.denominator * Me.numerator + Nombre.numerator * Me.denominator)
Me.denominator = (Nombre.denominator * Me.denominator)

Regulariser

End Sub

Public Sub Multiplier_Par(Nombre As Rationnel)

Me.numerator = (numerator * Nombre.numerator)
Me.denominator = (denominator * Nombre.denominator)

Regulariser

End Sub

Public Sub Diviser_Par(Nombre As Rationnel)

Me.numerator = (numerator * Nombre.denominator)
Me.denominator = (denominator * Nombre.numerator)

Regulariser

End Sub

Public Function Valeur(Optional Approche = False) As Variant

If Approche Then
    Valeur = (Me.numerator / Me.denominator)
Else
    Valeur = FaireBeau
End If

End Function

Private Function PGCD(a As Double, b As Double) As Double
Dim r As Double

Do
r = (a Mod b)
a = b
b = r
Loop Until (r = 0)

PGCD = a

End Function

Private Sub Regulariser()
Dim a As Double

a = PGCD(Me.numerator, Me.denominator)

Me.numerator = (Me.numerator / a)
Me.denominator = (Me.denominator / a)

End Sub

Private Function FaireBeau() As String
Regulariser

If Me.denominator = 1 Then
    FaireBeau = CStr(Me.numerator)
Else
    FaireBeau = CStr(Me.numerator) & "/" & CStr(Me.denominator)
End If

End Function

Public Function Signe() As Sign
Dim a As Double

a = numerator * denominator

If a < 0 Then Signe = Moins
If a = 0 Then Signe = Nul
If a > 0 Then Signe = Plus

End Function

Public Function ValeurAbsolue() As String
Dim a As New Rationnel

a.numerator = Me.numerator
a.denominator = Me.denominator

a.numerator = Abs(a.numerator)
a.denominator = Abs(a.denominator)

ValeurAbsolue = a.Valeur

End Function
